unit eventun;


Interface



    procedure readin;
    function convert(anguish:string):longint;
    procedure playerrun;
    function FileExists(FName: STRING): Boolean;
    procedure mailrun;
    procedure logwrite;
    procedure chooseevent;
    procedure chk4reg(nom:string;bbs:string;reg:longint);
    procedure mainloop;

implementation

uses crt,dos;


type event_type = record
           message:string[70];
           message2: string[70];
           message3: string[70];
           log: string[75];
           expinc: string[35];
           definc: string[35];
           strinc: string[35];
           hitinc: string[35];
           ffinc : string[35];
           pfinc : string[35];
           goldinc: string[35];
           Directed: string[35];
           dirvar: byte;
           pair:integer;
         end;

player_info = record
  names: string[20]; {player handle in the game}
real_names: string[50] {real name/or handle from BBS} ;
hit_points  {player hit points}
,bad  {don't know - might not be used at all}
,rate: integer; {again, couldn't find this one in the source}
hit_max: integer; {hit_point max}
weapon_num: integer; {weapon number}
weapon: string[20]; {name of weapon}
seen_master: integer; {equals 5 if seen master, else 0}
fights_left: integer; {forest fights left}
human_left: integer; {human fights left}
gold: longint; {gold in hand}
bank: longint; {gold in bank}
def: integer;  {total defense points }
strength: integer; {total strength}
charm: integer; {good looking meter}
seen_dragon: integer; {seen dragon?  5 if yes else 0}
seen_violet: integer; {seen violet?  5 if yes else 0}
level: integer; {level of player}
time: word; {day # that player last played on}
arm: string[20]; {armour name}
arm_num: integer; {armour number}
dead: shortint; {player dead?  5 if yes else 0}
inn: shortint; {player sleeping at inn?  5 if yes else 0}
gem: integer; {# of gems on hand}
exp: longint; {experience}
sex: shortint; {gender, 5 if female else 0}
seen_bard: shortint; {seen bard?  5 if yes else 0}
last_alive_time: integer; {day # player was last reincarnated on}
Lays: integer; {players lays stat}
Why: integer; {not used yet}
on_now: boolean; {is player on?}
m_time: integer; {day on_now stat was last used}
time_on: string[5]; {time player logged on in Hour:Minutes format}
class: shortint; {class, should be 1, 2 or 3}
extra: integer;      {can't remember}
love: string[25]; {not used - may be used for inter-player marrages later}
married: integer; {who player is married to, should be -1 if not married}
kids: integer; {# of kids}
king: integer; {# of times player has won game}
skillw: shortint; {number of Death Knight skill points}
skillm: shortint; {number of Mystical Skills points}
skillt: shortint; {number of Thieving Skills points}

levelw: shortint; {number of Death Knight skill uses left today}
levelm: shortint; {number of Mystical skill uses left today}
levelt: shortint; {number of Thieving skill uses left today}

inn_random: boolean; {not used yet}
married_to: integer; {same as Married, I think - don't know why it's here}
v1: longint;
v2: integer; {# of player kills}
v3: integer; {if 5, 'wierd' event in forest will happen}
v4: boolean; {has player done 'special' for that day?}
v5: shortint; {has player flirted with another player that day?  if so, 5}
  new_stat1: shortint;
  new_stat2: shortint;  {these 3 are unused right now}
  new_stat3: shortint;
  end;

var z,t:byte;
    i,y:byte;
    playrec: array[1..149] of player_info;
    playfile: file of player_info;
    evenrec2: event_type;
    path:string[50];



procedure READIN;
  begin
    i := 0;
    assign(playfile,path+'player.dat');
    reset(playfile);
    repeat
      inc(i);
      read(playfile,playrec[i]);
      IF PLAYREC[I].on_now then begin
         writeln('A PLAYER IS ON-LINE!');
         close(playfile);
         halt;
      end;
    until eof(playfile);
  end;


procedure playerrun;
 label yank;
  var d,b,v:byte;
   data: text;
   tempstr,anguish,f,g,h:string;
   female,male,above,below,first,last,rand:boolean;
   valled: longint;
  begin
    female := false;
    male := false;
    above := false;
    below := false;
    first := false;
    last := false;
    rand := false;
    d := 1;
    b := i;
    IF evenrec2.directed = 'Female' then female := true;
    IF evenrec2.directed = 'Male' then male := true;
    IF evenrec2.directed = 'Above' then above := true;
    IF evenrec2.directed = 'Below' then below := true;
    IF evenrec2.directed = 'First' then first := true;
    IF evenrec2.directed = 'Random' then rand := true;
    IF FIRST and (b > evenrec2.dirvar) then b := evenrec2.dirvar;
    IF LAST AND (d > evenrec2.dirvar) then d := evenrec2.dirvar;
    for z := d to b do begin
      if (playrec[z].real_names = 'X') or (playrec[z].names = '') then goto yank;
      IF FEMALE And (Playrec[z].sex = 0) then goto yank;
      IF MALE and (playrec[z].sex = 5) then goto yank;
      IF BELOW and (playrec[z].level > evenrec2.dirvar) then goto yank;
      IF ABOVE and (playrec[z].level < evenrec2.dirvar) then goto yank;
      IF (RAND) and not (RANDOM(evenrec2.dirvar) = 0) then goto yank;
      IF RAND then begin
         assign(data, path+'mail'+tempstr+'.dat');
         append(data);
         writeln(data,'`2');
         writeln(data,'`%                          -*- Lord Event -*-');
         writeln(data,'`2-=-=-=--=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=');
         IF POS('BLANK',evenrec2.message) = 0 then writeln(data,'`2  ',evenrec2.message);
         IF POS('BLANK',evenrec2.message2) = 0 then writeln(data,'`2  ',evenrec2.message2);
         IF POS('BLANK',evenrec2.message3) = 0 then writeln(data,'`2  ',evenrec2.message3);
         writeln(data,'`2');
         close(data);
      end;
        IF NOT (evenrec2.expinc = '0') then begin
           valled := convert(evenrec2.expinc);
           IF (playrec[z].exp - valled) > 0 then dec(playrec[z].exp,valled) else playrec[z].exp := 2;
        end;
        IF NOT (evenrec2.definc = '0') then begin
           valled := convert(evenrec2.definc);
           IF (playrec[z].def - valled) > 0 then dec(playrec[z].def,valled) else playrec[z].def := 1;
        end;
        IF NOT (evenrec2.strinc = '0') then begin
           valled := convert(evenrec2.strinc);
           IF (playrec[z].strength - valled) > 0 then dec(playrec[z].strength,valled) else playrec[z].strength := 2;
        end;
        IF NOT (evenrec2.hitinc = '0') then begin
           valled := convert(evenrec2.hitinc);
           IF (playrec[z].hit_max - valled) > 0 then dec(playrec[z].hit_max,valled) else playrec[z].hit_max := 20;
        end;
        IF NOT (evenrec2.ffinc = '0') then begin
           valled := convert(evenrec2.ffinc);
           IF (playrec[z].fights_left - valled) > 0 then dec(playrec[z].fights_left,valled) else playrec[z].fights_left := 0;
        end;
        IF NOT (evenrec2.pfinc = '0') then begin
           valled := convert(evenrec2.pfinc);
           IF (playrec[z].human_left - valled) > 0 then dec(playrec[z].human_left,valled) else playrec[z].human_left := 0;
        end;
        IF NOT (evenrec2.goldinc = '0') then begin
           valled := convert(evenrec2.goldinc);
           IF (playrec[z].bank - valled) > 0 then dec(playrec[z].bank,valled) else playrec[z].bank := 0;
        end;
    yank:
  end;
end;


function FileExists(FName: STRING): Boolean;
  Var TFile: TEXT;
      S: String;
  Begin
    s := FSEARCH(FNAME, '');
    FileExists := S <> '';
  end;




procedure mailrun;
 label yank;
 var tempstr: string;
   data: text;
   d,b:byte;
  female,male,above,below,first,last,rand:boolean;

  begin

    female := false;
    male := false;
    above := false;
    below := false;
    first := false;
    last := false;
    rand := false;
    d := 1;
    b := i;
    readln;
    IF evenrec2.directed = 'Female' then female := true;
    IF evenrec2.directed = 'Male' then male := true;
    IF evenrec2.directed = 'Above' then above := true;
    IF evenrec2.directed = 'Below' then below := true;
    IF evenrec2.directed = 'First' then first := true;
    IF evenrec2.directed = 'Random' then rand := true;
    IF rand then begin
       exit;
    end;
    IF FIRST and (b > evenrec2.dirvar) then b := evenrec2.dirvar;
    IF LAST AND (d > evenrec2.dirvar) then d := evenrec2.dirvar;

    for z := d to b do begin

       str(z-1,tempstr);
       if (playrec[z].real_names = 'X') or (playrec[z].names = '') then goto yank;
      IF FEMALE And (Playrec[z].sex = 0) then goto yank;
      IF MALE and (playrec[z].sex = 5) then goto yank;
      IF BELOW and (playrec[z].level > evenrec2.dirvar) then goto yank;
      IF ABOVE and (playrec[z].level < evenrec2.dirvar) then goto yank;
      assign(data, path+'mail'+tempstr+'.dat');
      append(data);
      writeln(data,'`2');
      writeln(data,'`%                          -*- Lord Event -*-');
      writeln(data,'`2-=-=-=--=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=');
      IF POS('BLANK',evenrec2.message) = 0 then writeln(data,'`2  ',evenrec2.message);
      IF POS('BLANK',evenrec2.message2) = 0 then writeln(data,'`2  ',evenrec2.message2);
      IF POS('BLANK',evenrec2.message3) = 0 then writeln(data,'`2  ',evenrec2.message3);
      writeln(data,'`2');
      close(data);
      yank:
    end;
end;


function convert(anguish:string):longint;
label a1;
var v:byte;
   tempstr,f,g,h:string;
   errcode:integer;
   valled:longint;
begin
    a1:
           IF POS('LEVEL',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('LEVEL',anguish)-1) do f := f + anguish[v];
               for v := (POS('LEVEL',anguish)+6) to length(anguish) do h := h +anguish[v];
               str(playrec[z].level,tempstr);
               g := tempstr;
               anguish := f+g+h;
               goto a1;
           end;
    val(anguish,valled,errcode);
    convert := valled;
end;


 procedure logwrite;
  var ty,ti : byte;
      temp:array[1..200] of string;
      devilish:string;
      line1,line2,line3,lin4:string;
      data: text;
  begin
    IF POS(evenrec2.log,'BLANK')>0 then exit;
    assign(data,path+'lognow.txt');
    reset(data);
    ty := 0;
    repeat
      inc(ty);
      readln(data, temp[ty]);
    until eof(data);
    close(data);
    assign(data,path+'lognow.txt');
    rewrite(data);
    writeln(data,temp[1]);
    writeln(data,temp[2]);
    writeln(data,temp[3]);
    writeln(data,temp[4]);
    writeln(data,'`2  ',evenrec2.log);
    writeln(data,'`.                                `2-`0=`2-`0=`2-`0=`2-');
    for ti := 5 to ty do writeln(data, temp[ti]);
    close(data);
  end;


 procedure chooseevent;
  var thatvar:byte;
     evenrec: array[1..50] of event_type;
     evenfile: file of event_type;
  begin
    t := 0;
    assign(evenfile,'event.dat');
    reset(evenfile);
    repeat
      inc(t);
      read(evenfile,evenrec[t]);
    until eof(evenfile);
    thatvar := (RANDOM(t));
    t := thatvar+1;
    evenrec2 := evenrec[t];
  end;

procedure chk4reg(nom:string;bbs:string;reg:longint);
  var hiyadude:byte;
      reg2:longint;
      registered:boolean;
  begin
    IF Length(NOM) < 5 then for hiyadude := (Length(NOM)+1) to 5 do Nom[hiyadude] := 'Z';
    IF Length(bbs) < 5 then for hiyadude := (Length(bbs)+1) to 5 do bbs[hiyadude] := 'Z';
   reg2:=(ORD(nom[1])+ORD(nom[2])+ORD(bbs[1])+ORD(bbs[2])*ORD(nom[3])*ORD(BBS[3])*ORD(nom[4])*ORD(bbs[4])+ORD(nom[5])
   +ORD(bbs[5])*45);
   IF REG = REG2 then registered := true;
  end;



procedure mainloop;
label ten1;
var gar4,gar2,gar3,gar:byte;
    rec:array[1..10] of byte;
    year,month,day,dow:word;
    nom,bbs,path:string[80];
    reg:longint;
    data,data2: text;
    datetest2,datetest:string[5];
begin
  assign(data, 'event.cfg');
  reset(data);
  readln(data, nom);
  readln(data, bbs);
  readln(data, path);
  readln(data, gar);
  readln(data, gar2);
  readln(data,reg);
  close(data);
  chk4reg(nom,bbs,reg);
  gar4 := 0;
  IF (gar = 1) and (random(gar2) = 0) then begin
    ten1:
    chooseevent;
    inc(gar4);
    rec[gar4] := t;
    writeln('Choosing Event...');
    logwrite;
    writeln;
    writeln('Writing Log...');
    writeln;
    playerrun;
    writeln('Running through players...');
    writeln;
    mailrun;
    writeln('Running through player mail...');
    IF (evenrec2.pair > 0) and NOT (evenrec2.pair = rec[1]) then begin
      t := evenrec2.pair;
      goto ten1;
    end;
    halt;
  end;
  IF (gar = 0) then for gar3 := 1 to gar2 do begin
    chooseevent;
    writeln('Choosing Event...');
    logwrite;
    writeln;
    writeln('Writing Log...');
    writeln;
    playerrun;
    writeln('Running through players...');
    writeln;
    mailrun;
    writeln('Running through player mail...');
  end;
end;
end.