program LordEvent;

uses crt,dos;

label next,ten1,ten2;

  type player_info = record
  names: string[20]; {player handle in the game}
real_names: string[50] {real name/or handle from BBS} ;
hit_points  {player hit points}
,bad  {don't know - might not be used at all}
,rate: integer; {again, couldn't find this one in the source}
hit_max: integer; {hit_point max}
weapon_num: integer; {weapon number}
weapon: string[20]; {name of weapon}
seen_master: integer; {equals 5 if seen master, else 0}
fights_left: integer; {forest fights left}
human_left: integer; {human fights left}
gold: longint; {gold in hand}
bank: longint; {gold in bank}
def: integer;  {total defense points }
strength: integer; {total strength}
charm: integer; {good looking meter}
seen_dragon: integer; {seen dragon?  5 if yes else 0}
seen_violet: integer; {seen violet?  5 if yes else 0}
level: integer; {level of player}
time: word; {day # that player last played on}
arm: string[20]; {armour name}
arm_num: integer; {armour number}
dead: shortint; {player dead?  5 if yes else 0}
inn: shortint; {player sleeping at inn?  5 if yes else 0}
gem: integer; {# of gems on hand}
exp: longint; {experience}
sex: shortint; {gender, 5 if female else 0}
seen_bard: shortint; {seen bard?  5 if yes else 0}
last_alive_time: integer; {day # player was last reincarnated on}
Lays: integer; {players lays stat}
Why: integer; {not used yet}
on_now: boolean; {is player on?}
m_time: integer; {day on_now stat was last used}
time_on: string[5]; {time player logged on in Hour:Minutes format}
class: shortint; {class, should be 1, 2 or 3}
extra: integer;      {can't remember}
love: string[25]; {not used - may be used for inter-player marrages later}
married: integer; {who player is married to, should be -1 if not married}
kids: integer; {# of kids}
king: integer; {# of times player has won game}
skillw: shortint; {number of Death Knight skill points}
skillm: shortint; {number of Mystical Skills points}
skillt: shortint; {number of Thieving Skills points}

levelw: shortint; {number of Death Knight skill uses left today}
levelm: shortint; {number of Mystical skill uses left today}
levelt: shortint; {number of Thieving skill uses left today}

inn_random: boolean; {not used yet}
married_to: integer; {same as Married, I think - don't know why it's here}
v1: longint;
v2: integer; {# of player kills}
v3: integer; {if 5, 'wierd' event in forest will happen}
v4: boolean; {has player done 'special' for that day?}
v5: shortint; {has player flirted with another player that day?  if so, 5}
  new_stat1: shortint;
  new_stat2: shortint;  {these 3 are unused right now}
  new_stat3: shortint;
  end;

event_type = record
           message:string[70];
           message2: string[70];
           message3: string[70];
           log: string[75];
           expinc: string[35];
           definc: string[35];
           strinc: string[35];
           hitinc: string[35];
           ffinc : string[35];
           pfinc : string[35];
           goldinc:string[35];
           skillinc:string[35];
           charminc:string[35];
           laysinc:string[35];
           Directed: string[35];
           dirvar: byte;
           pair:integer;
         end;


var
    o,z,t:byte;
    i,y:byte;
    playrec: array[1..149] of ^player_info;
    evenrec: array[1..50] of event_type;
    evenfile: file of event_type;
    gar4,gar3,gar,gar2:byte;
    rec:array[1..10] of byte;
    donor:array[1..149] of byte;
    data,data2: text;
    playfile:file of player_info;
    registered: boolean;
    datetest2,datetest,nom,bbs,path:string[80];
    year,month,day,dow:word;
    reg:longint;
    uck:array[1..150] of byte;
    uckp:byte;

function FileExists(FName: STRING): Boolean;
  Var TFile: TEXT;
      S: String;
  Begin
    s := FSEARCH(FNAME, '');
    FileExists := S <> '';
  end;



procedure chk4reg;
  var hiyadude:byte;
      reg2:longint;
  begin
    IF Length(NOM) < 5 then for hiyadude := (Length(NOM)+1) to 5 do Nom[hiyadude] := 'Z';
    IF Length(bbs) < 5 then for hiyadude := (Length(bbs)+1) to 5 do bbs[hiyadude] := 'Z';
   reg2:=(ORD(nom[1])+ORD(nom[2])+ORD(bbs[1])+ORD(bbs[2])*ORD(nom[3])*ORD(BBS[3])*ORD(nom[4])*ORD(bbs[4])+ORD(nom[5])
   +ORD(bbs[5])*45);
   IF REG = REG2 then registered := true;
  end;

procedure colordisplay;
 var r:byte;
  begin
    for r := 1 to 9 do begin
      textcolor(r);
      write('`',r,' ');
    end;
      textcolor(10);
      write('`0 ');
      textcolor(11);
      write('`! ');
      textcolor(12);
      write('`@ ');
      textcolor(13);
      write('`# ');
      textcolor(14);
      write('`$ ');
      textcolor(15);
      write('`% ');
   end;


procedure flush;
 var ch:char;
  begin
    ch := readkey;
    ch := readkey;
  end;


function lineedit(x:byte;y:byte;tempstr:string;lengths:byte):string;
var temp:string;
    fir,d,t:byte;
    done,first,insert,macho:boolean;
    ch:char;
label finish,donu;
  begin
    fir := length(tempstr);
    insert := true;
    gotoxy(1,22);
    writeln;
    gotoxy(1,23);
    textcolor(14);
    write('MODE: ');
    textcolor(10);
    writeln('INSERT');
    writeln;
    done :=false;
    first := true;
    textcolor(15);
    gotoxy(1,y);
    write(tempstr);
{    for d := length(tempstr)+1 to lengths do tempstr[d] := ' ';}
    temp := '';
    for d := 1 to lengths do temp := temp + ' ';
    for d := 1 to length(tempstr) do temp[d] := tempstr[d];
    tempstr := temp;
    repeat
      gotoxy(x,y);
      ch := readkey;
      IF (ORD(CH) = 0) then begin
        ch := readkey;
        CASE ORD(CH) of
          71: begin
                for d := 1 to lengths do tempstr[d] := ' ';
                x := 1;
                gotoxy(1,y);
                writeln(' ':79);
                gotoxy(1,y);
              end;
          77: IF x < lengths then inc(x);
          75: IF x > 1 then dec(x);
          82: begin
                IF INSERT then begin
                   insert := false;
                   gotoxy(7,23);
                   writeln('OVERWRITE');
                end
                else begin
                   insert := true;
                   gotoxy(7,23);
                   writeln('INSERT   ');
                end;
              end;
          83: begin
                for d := x to (lengths-1) do tempstr[d] := tempstr[d+1];
                tempstr[lengths] := ' ';
                for d := x to lengths do write(tempstr[d]);
              end;
              end;
        goto finish;
      end;
      IF ORD(CH) = 13 then begin
         done := true;
         goto finish;
      end;
      IF ORD(CH) = 8 then begin
         IF X > 1 then tempstr[x-1] := ' ';
         gotoxy(x-1,y);
         write(' ');
         IF x > 1 then dec(x);
         goto finish;
      end;
      IF ORD(CH) = 32 then begin
         IF INSERT then begin
             for d := (lengths-1) downto x do tempstr[d+1] := tempstr[d];
             tempstr[x] := ' ';
             for d := x to lengths do write(tempstr[d]);
             IF x < lengths then inc(x);
         end
         else begin
           tempstr[x] := ' ';
           IF x < lengths then inc(x);
         end;
         goto finish;
      end;
  {  IF FIRST then begin
       for d := 1 to lengths do tempstr[d] := ' ';
       x := 1;
       gotoxy(x,y);
       writeln(' ':lengths);
       gotoxy(x,y);
       goto finish;
    end;}
    IF INSERT then begin
        for d := (lengths-1) downto x do tempstr[d+1] := tempstr[d];
        tempstr[x] := ch;
        for d := x to lengths do write(tempstr[d]);
        inc(x);
        goto finish;
    end;
    tempstr[x] := ch;
    write(tempstr[x]);
    IF X < lengths then inc(x);
    finish:
    first := false;
   until done;
   macho := false;
   for d := 1 to lengths do begin
     IF tempstr[d] = ' ' then macho := true;
     IF macho then goto donu;
   end;
   donu:
   IF MACHO then d := d-1;
   temp := '';
   {for t := 1 to d do temp := temp + tempstr[t];}
   IF (POS('   ', tempstr) > 0) then for t := 1 to (POS('   ',tempstr)-1) do temp := temp + tempstr[t];
   tempstr := temp;
   lineedit := tempstr;
  end;


procedure runother;
 var ch:char;
  begin
    ch := readkey;
    clrscr;
    CASE UPCASE(ch) of
     '1': begin
            evenrec[t].directed := 'All';
            evenrec[t].dirvar := 0;
          end;
     '2': begin
            evenrec[t].directed := 'Female';
            evenrec[t].dirvar := 0;
          end;
     '3': begin
            evenrec[t].directed := 'Male';
            evenrec[t].dirvar := 0;
          end;
     '9': begin
            evenrec[t].directed := 'Inn';
            evenrec[t].dirvar := 0;
          end;
     '0': begin
            evenrec[t].directed := 'Fields';
            evenrec[t].dirvar := 0;
          end;
     'A': begin
            evenrec[t].directed := 'Kids';
            evenrec[t].dirvar := 0;
          end;
     '4': begin
            evenrec[t].directed := 'Above';
            gotoxy(1,17);
            writeln(' ':79);
            textcolor(15);
            write('What level would you like to be the minimum level? > ');
            readln(evenrec[t].dirvar);
          end;
     '5': begin
            evenrec[t].directed := 'Below';
            gotoxy(1,17);
            writeln(' ':79);
            textcolor(15);
            write('What level would you like to be the maximum level? > ');
            readln(evenrec[t].dirvar);
          end;
     '6': begin
            evenrec[t].directed := 'First';
            gotoxy(1,17);
            writeln(' ':79);
            textcolor(15);
            write('What User would you like to be the last one? > ');
            readln(evenrec[t].dirvar);
          end;
     '7': begin
            evenrec[t].directed := 'Last';
            gotoxy(1,17);
            writeln(' ':79);
            textcolor(15);
            write('What User would you like to be the First one? > ');
            readln(evenrec[t].dirvar);
          end;
     '8': begin
            evenrec[t].directed := 'Random';
            gotoxy(1,17);
            writeln(' ':79);
            textcolor(15);
            write('Random chance (1 out of ?) of a player getting the event? > ');
            readln(evenrec[t].dirvar);
          end;
     end;
end;


procedure swriteln(s:string);
 label DEVIL;
 var f,g,h: string;
     done:boolean;
     q:byte;
  begin
    done := false;
    IF NOT POS('`',s) > 0 then begin
      writeln(s);
      exit;
    end;
   repeat
    IF s[pos('`',s)+1] IN ['0','1','2','3','4','5','6','7','8','9','!','@','#','$','%'] then begin
       g := '';
       for q := 1 to POS('`',s)-1 do g := g + s[q];
       write(g);
       CASE s[POS('`',s)+1] of
       '1':textcolor(1);
       '2':textcolor(2);
       '3':textcolor(3);
       '4':textcolor(4);
       '5':textcolor(5);
       '6':textcolor(6);
       '7':textcolor(7);
       '8':textcolor(8);
       '9':textcolor(9);
       '0':textcolor(10);
       '!':textcolor(11);
       '@':textcolor(12);
       '#':textcolor(13);
       '$':textcolor(14);
       '%':textcolor(15);
       end;
       f := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       s := f;
       end;
   until POS('`',s) = 0;
   writeln(s);
  end;


procedure swrite(s:string);
 label DEVIL;
 var f,g,h: string;
     done:boolean;
     q:byte;
  begin
    done := false;
    IF NOT POS('`',s) > 0 then begin
      writeln(s);
      exit;
    end;
   repeat
    IF s[pos('`',s)+1] IN ['0','1','2','3','4','5','6','7','8','9','!','@','#','$','%'] then begin
       g := '';
       for q := 1 to POS('`',s)-1 do g := g + s[q];
       write(g);
       CASE s[POS('`',s)+1] of
       '1':textcolor(1);
       '2':textcolor(2);
       '3':textcolor(3);
       '4':textcolor(4);
       '5':textcolor(5);
       '6':textcolor(6);
       '7':textcolor(7);
       '8':textcolor(8);
       '9':textcolor(9);
       '0':textcolor(10);
       '!':textcolor(11);
       '@':textcolor(12);
       '#':textcolor(13);
       '$':textcolor(14);
       '%':textcolor(15);
       end;
       f := '';
       for q := (POS('`',s)+2) to length(s) do f := f + s[q];
       s := f;
       end;
   until POS('`',s) = 0;
   write(s);
  end;




procedure eventedit;
label a1,a2,a3,a4,a5,a6,a7,x2,a8,a9,a10;
var  r,v,e,w,l:byte;
  ch:char;
  tempstr,anguish : string;
  f,g,h:string[80];
  valled:longint;
  errcode:integer;
  done:boolean;
  begin
    w := 0;
    assign(evenfile,'event.dat');
    reset(evenfile);
    repeat
      inc(w);
      read(evenfile,evenrec[w]);
    until eof(evenfile);
    close(evenfile);
    t := 1;
    done := false;
    r := 1;
    v := 1;
    repeat
    x2:
    clrscr;
    textcolor(10);
    writeln('Event ',t, ' of ',w);
    writeln;
    textcolor(10);
    writeln('Message Displayed In Mail to Player:');
    write('1) ');
    textcolor(11);
    swriteln(evenrec[t].message);
    textcolor(10);
    write('2) ');
    textcolor(11);
    swriteln(evenrec[t].message2);
    textcolor(10);
    write('3) ');
    textcolor(11);
    swriteln(evenrec[t].message3);
    textcolor(10);
    writeln('Message Displayed In Log:');
    write('4) ');
    textcolor(11);
    swriteln(evenrec[t].log);
    textcolor(10);
    write('5) Experience Change: ');
    textcolor(11);
    writeln(evenrec[t].expinc);
    textcolor(10);
    write('6) Defense Change   : ');
    textcolor(11);
    writeln(evenrec[t].definc);
    textcolor(10);
    write('7) Strength Change  : ');
    textcolor(11);
    writeln(evenrec[t].strinc);
    textcolor(10);
    write('8) HitPoints Change : ');
    textcolor(11);
    writeln(evenrec[t].hitinc);
    textcolor(10);
    write('9) Forest Fights Chg: ');
    textcolor(11);
    writeln(evenrec[t].ffinc);
    textcolor(10);
    write('A) User Fights Chg  : ');
    textcolor(11);
    writeln(evenrec[t].pfinc);
    textcolor(10);
    write('B) Bank Gold Change : ');
    textcolor(11);
    writeln(evenrec[t].goldinc);
    textcolor(10);
    write('C) Charm Change     : ');
    textcolor(11);
    writeln(evenrec[t].charminc);
    textcolor(10);
    write('D) Lays Change      : ');
    textcolor(11);
    writeln(evenrec[t].laysinc);
    textcolor(10);
    write('E) Skill Change     : ');
    textcolor(11);
    writeln(evenrec[t].skillinc);
    textcolor(10);
    write('F) Event Directed At: ');
    textcolor(11);
    write(evenrec[t].directed);
    IF evenrec[t].dirvar > 0 then write('(',evenrec[t].dirvar,')');
    writeln;
    textcolor(10);
    write('G) Event Paired To: ');
    IF evenrec[t].PAIR > 0 then write(evenrec[t].pair) else write('None');
    writeln;
    writeln;
    writeln;
    textcolor(9);
    writeln(' (>) Increase One Event   (<) Decrease One Event   (X) Delete Event');
    writeln(' (N) New Event            (]) Copy Event           (Q) Quit to Main');
    ch := readkey;
    CASE UPCASE(ch) OF
    '1':begin
          clrscr;
          gotoxy(1,1);
          textcolor(14);
          writeln('This is the message sent to a player who receives the event.');
          writeln('Use % and then one of the following numbers to refer to the amount change.');
          writeln('The change is ALWAYS reported in the POSITIVE amount.');
          writeln('1:Exp  2:Def  3:Str  4:HP  5:FrstF  6:UserF  7:Gold  8:Chrm  9:Kids  0:Skill');
          textcolor(10);
          writeln('Enter in the phrase for Line 1 Below.  You have 70 characters.       |');
          writeln;
          textcolor(7);
          writeln('^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^');
          textcolor(14);
          writeln('You may also use the LORD color codes in this message. They are:');
          colordisplay;
          tempstr := lineedit(length(evenrec[t].message)+1, 6,evenrec[t].message,70);
          if NOT (tempstr = '') then evenrec[t].message := tempstr;
        end;
    '2':begin
          clrscr;
          gotoxy(1,1);
          textcolor(14);
          writeln('This is the message sent to a player who receives the event.');
          writeln('Use % and then one of the following numbers to refer to the amount change.');
          writeln('The change is ALWAYS reported in the POSITIVE amount.');
          writeln('1:Exp  2:Def  3:Str  4:HP  5:FrstF  6:UserF  7:Gold  8:Chrm  9:Kids  0:Skill');
          writeln('Just type BLANK (in all caps), and then ENTER to set it blank.');
          textcolor(10);
          writeln('Enter in the phrase for Line 2 Below.  You have 70 characters.       |');
          writeln;
          textcolor(7);
          writeln('^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^');
          textcolor(14);
          writeln('You may also use the LORD color codes in this message. They are:');
          colordisplay;
          tempstr := lineedit(length(evenrec[t].message2)+1, 7,evenrec[t].message2,70);
          if NOT (tempstr = '') then evenrec[t].message2 := tempstr;
        end;
    '3':begin
          clrscr;
          gotoxy(1,1);
          textcolor(14);
          writeln('This is the message sent to a player who receives the event.');
          writeln('Use % and then one of the following numbers to refer to the amount change.');
          writeln('The change is ALWAYS reported in the POSITIVE amount.');
          writeln('1:Exp  2:Def  3:Str  4:HP  5:FrstF  6:UserF  7:Gold  8:Chrm  9:Kids  0:Skill');
          writeln;
          writeln('Enter in the phrase for Line 3 Below.  You have 70 characters.       |');
          writeln('Just type BLANK (in all caps), and then ENTER to set it blank.');
          writeln;
          textcolor(7);
          writeln('^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^');
          textcolor(14);
          writeln('You may also use the LORD color codes in this message. They are:');
          colordisplay;
          tempstr := lineedit(length(evenrec[t].message3)+1, 8,evenrec[t].message3,70);
          if NOT (tempstr = '') then evenrec[t].message3 := tempstr;
        end;
    '4':begin
          clrscr;
          gotoxy(1,1);
          textcolor(14);
          writeln;
          writeln;
          writeln('This is the message written to the log describing the event.');
          writeln('You may also use the LORD color codes in this message. They are:');
          colordisplay;
          writeln;
          writeln;
          writeln('Just type BLANK (in all caps), and then ENTER to set it blank.');          textcolor(10);
          writeln;
          writeln('Enter in the phrase for the log Below.  You have 75 characters.             |');
          writeln;
          textcolor(7);
          writeln('^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^');
          tempstr := lineedit(length(evenrec[t].log)+1, 10,evenrec[t].log,75);
          if NOT (tempstr = '') then evenrec[t].log := tempstr;
        end;
    '5': begin
           gotoxy(1,5);
           writeln(' ':79);
           textcolor(14);
           writeln('This is the CHANGE of EXPERIENCE given to a player who gets this event.');
           writeln('Use "LEVEL" (all caps) for a user''s level, * for multiplication,');
           writeln('And \ for division.  Sorry, no Exponents, just use Number*Number.');
           writeln('Use a % sign at the end to do percents (i.e. 5% would be 5 percent)');
           writeln(' ':79);
           textcolor(13);
           write('Experience? > ',' ':73);
           writeln(' ':79);
           gotoxy(15,11);
           readln(tempstr);
           anguish := tempstr;
           IF LENGTH(anguish) > 34 then begin
             writeln(' ':79);
             writeln('String Too Long.');
             readln;
             goto x2;
           end;
           a1:
           IF POS('LEVEL',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('LEVEL',anguish)-1) do f := f + anguish[v];
               for v := (POS('LEVEL',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '1';
               anguish := f+g+h;
               goto a1;
           end;
           IF POS('%',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('%',anguish)-1) do f := f + anguish[v];
               for v := (POS('%',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '';
               anguish := f+g+h;
               goto a1;
           end;
           val(anguish,valled,errcode);
           IF ERRCODE = 0 then evenrec[t].expinc := tempstr;
         end;
      '6': begin
           gotoxy(1,6);
           writeln(' ':79);
           textcolor(14);
           writeln('This is the CHANGE of DEFENSE given to a player who gets this event.');
           writeln('Use "LEVEL" (all caps) for a user''s level, * for multiplication,');
           writeln('And \ for division.  Sorry, no Exponents, just use Number*Number.');
           writeln('Use a % sign at the end to do percents (i.e. 5% would be 5 percent)');
           textcolor(13);
           writeln(' ':79);
           write('Defense? > ',' ':70);
           writeln(' ':79);
           gotoxy(12,12);
           readln(tempstr);
           anguish := tempstr;
           IF LENGTH(anguish) > 34 then begin
             writeln(' ':79);
             writeln('String Too Long.');
             readln;
             goto x2;
           end;
           a2:
           IF POS('%',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('%',anguish)-1) do f := f + anguish[v];
               for v := (POS('%',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '';
               anguish := f+g+h;
               goto a2;
           end;
           IF POS('LEVEL',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('LEVEL',anguish)-1) do f := f + anguish[v];
               for v := (POS('LEVEL',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '1';
               anguish := f+g+h;
               goto a2;
           end;
           val(anguish,valled,errcode);
           IF ERRCODE = 0 then evenrec[t].definc := tempstr;
         end;
      '7': begin
           gotoxy(1,7);
           writeln(' ':79);
           textcolor(14);
           writeln('This is the CHANGE of STRENGTH given to a player who gets this event.');
           writeln('Use "LEVEL" (all caps) for a user''s level, * for multiplication,');
           writeln('And \ for division.  Sorry, no Exponents, just use Number*Number.');
           writeln('Use a % sign at the end to do percents (i.e. 5% would be 5 percent)');
           writeln(' ':79);
           textcolor(13);
           write('Strength? > ',' ':70);
           writeln(' ':79);
           gotoxy(13,13);
           readln(tempstr);
           anguish := tempstr;
           IF LENGTH(anguish) > 34 then begin
             writeln(' ':79);
             writeln('String Too Long.');
             readln;
             goto x2;
           end;
           a3:
           IF POS('%',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('%',anguish)-1) do f := f + anguish[v];
               for v := (POS('%',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '';
               anguish := f+g+h;
               goto a3;
           end;
           IF POS('LEVEL',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('LEVEL',anguish)-1) do f := f + anguish[v];
               for v := (POS('LEVEL',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '1';
               anguish := f+g+h;
               goto a3;
           end;
           val(anguish,valled,errcode);
           IF ERRCODE = 0 then evenrec[t].strinc := tempstr;
         end;
      '8': begin
           gotoxy(1,8);
           writeln(' ':79);
           textcolor(14);
           writeln('This is the CHANGE of MAX HITPOINTS given to a player who gets this event.');
           writeln('Use "LEVEL" (all caps) for a user''s level, * for multiplication,');
           writeln('And \ for division.  Sorry, no Exponents, just use Number*Number.');
           writeln('Use a % sign at the end to do percents (i.e. 5% would be 5 percent)');
           writeln(' ':79);
           textcolor(13);
           write('Hit Points? > ',' ':60);
           writeln(' ':79);
           gotoxy(15,14);
           readln(tempstr);
           anguish := tempstr;
           IF LENGTH(anguish) > 34 then begin
             writeln(' ':79);
             writeln('String Too Long.');
             readln;
             goto x2;
           end;
           a4:
           IF POS('%',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('%',anguish)-1) do f := f + anguish[v];
               for v := (POS('%',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '';
               anguish := f+g+h;
               goto a4;
           end;
           IF POS('LEVEL',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('LEVEL',anguish)-1) do f := f + anguish[v];
               for v := (POS('LEVEL',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '1';
               anguish := f+g+h;
               goto a4;
           end;
           val(anguish,valled,errcode);
           IF ERRCODE = 0 then evenrec[t].hitinc := tempstr;
         end;
      '9': begin
           gotoxy(1,9);
           writeln(' ':79);
           textcolor(14);
           writeln('This is the CHANGE of FOREST FIGHTS given to a player who gets this event.');
           writeln('Use "LEVEL" (all caps) for a user''s level, * for multiplication,');
           writeln('And \ for division.  Sorry, no Exponents, just use Number*Number.');
           writeln('Use a % sign at the end to do percents (i.e. 5% would be 5 percent)');
           writeln(' ':79);
           textcolor(13);
           write('Forest Fights? > ',' ':60);
           writeln(' ':79);
           gotoxy(18,15);
           readln(tempstr);
           anguish := tempstr;
           IF LENGTH(anguish) > 34 then begin
             writeln(' ':79);
             writeln('String Too Long.');
             readln;
             goto x2;
           end;
           a5:
           IF POS('%',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('%',anguish)-1) do f := f + anguish[v];
               for v := (POS('%',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '';
               anguish := f+g+h;
               goto a5;
           end;
           IF POS('LEVEL',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('LEVEL',anguish)-1) do f := f + anguish[v];
               for v := (POS('LEVEL',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '1';
               anguish := f+g+h;
               goto a5;
           end;
           val(anguish,valled,errcode);
           IF ERRCODE = 0 then evenrec[t].ffinc := tempstr;
         end;
      'A': begin
           gotoxy(1,10);
           writeln(' ':79);
           textcolor(14);
           writeln('This is the CHANGE of USER FIGHTS given to a player who gets this event.');
           writeln('Use "LEVEL" (all caps) for a user''s level, * for multiplication,');
           writeln('And \ for division.  Sorry, no Exponents, just use Number*Number.');
           writeln('Use a % sign at the end to do percents (i.e. 5% would be 5 percent)');
           writeln(' ':79);
           textcolor(13);
           write('User Fights? > ',' ':60);
           writeln(' ':79);
           gotoxy(16,16);
           readln(tempstr);
           anguish := tempstr;
           IF LENGTH(anguish) > 34 then begin
             writeln(' ':79);
             writeln('String Too Long.');
             readln;
             goto x2;
           end;
           a6:
           IF POS('%',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('%',anguish)-1) do f := f + anguish[v];
               for v := (POS('%',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '';
               anguish := f+g+h;
               goto a6;
           end;
           IF POS('LEVEL',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('LEVEL',anguish)-1) do f := f + anguish[v];
               for v := (POS('LEVEL',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '1';
               anguish := f+g+h;
               goto a6;
           end;
           val(anguish,valled,errcode);
           IF ERRCODE = 0 then evenrec[t].pfinc := tempstr;
         end;
      'B': begin
           gotoxy(1,11);
           writeln(' ':79);
           textcolor(14);
           writeln('This is the CHANGE of GOLD given to a player who gets this event.');
           writeln('Use "LEVEL" (all caps) for a user''s level, * for multiplication,');
           writeln('And \ for division.  Sorry, no Exponents, just use Number*Number.');
           writeln('Use a % sign at the end to do percents (i.e. 5% would be 5 percent)');
           writeln(' ':79);
           textcolor(13);
           write('Gold in Bank? > ',' ':60);
           writeln(' ':79);
           gotoxy(17,17);
           readln(tempstr);
           anguish := tempstr;
           IF LENGTH(anguish) > 34 then begin
             writeln(' ':79);
             writeln('String Too Long.');
             readln;
             goto x2;
           end;
           a7:
           IF POS('%',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('%',anguish)-1) do f := f + anguish[v];
               for v := (POS('%',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '';
               anguish := f+g+h;
               goto a7;
           end;
           IF POS('LEVEL',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('LEVEL',anguish)-1) do f := f + anguish[v];
               for v := (POS('LEVEL',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '1';
               anguish := f+g+h;
               goto a7;
           end;
           val(anguish,valled,errcode);
           IF ERRCODE = 0 then evenrec[t].goldinc := tempstr;
         end;
      'C': begin
           gotoxy(1,12);
           writeln(' ':79);
           textcolor(14);
           writeln('This is the CHANGE of CHARM given to a player who gets this event.');
           writeln('Use "LEVEL" (all caps) for a user''s level, * for multiplication,');
           writeln('And \ for division.  Sorry, no Exponents, just use Number*Number.');
           writeln('Use a % sign at the end to do percents (i.e. 5% would be 5 percent)');
           writeln(' ':79);
           textcolor(13);
           write('Charm Change? > ',' ':60);
           writeln(' ':79);
           gotoxy(17,18);
           readln(tempstr);
           anguish := tempstr;
           if anguish[1] = '-' then begin
             writeln(' ':79);
             writeln('Sorry, can''t do negatives with this variable.');
             readln;
             goto x2;
           end;
           IF LENGTH(anguish) > 34 then begin
             writeln(' ':79);
             writeln('String Too Long.');
             readln;
             goto x2;
           end;
           a8:
           IF POS('%',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('%',anguish)-1) do f := f + anguish[v];
               for v := (POS('%',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '';
               anguish := f+g+h;
               goto a8;
           end;
           IF POS('LEVEL',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('LEVEL',anguish)-1) do f := f + anguish[v];
               for v := (POS('LEVEL',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '1';
               anguish := f+g+h;
               goto a8;
           end;
           val(anguish,valled,errcode);
           IF ERRCODE = 0 then evenrec[t].charminc := tempstr;
         end;
      'D': begin
           gotoxy(1,13);
           writeln(' ':79);
           textcolor(14);
           writeln('This is the CHANGE of LAYS given to a player who gets this event.');
           writeln('Use "LEVEL" (all caps) for a user''s level, * for multiplication,');
           writeln('And \ for division.  Sorry, no Exponents, just use Number*Number.');
           writeln('Use a % sign at the end to do percents (i.e. 5% would be 5 percent)');
           writeln(' ':79);
           textcolor(13);
           write('Lays Change? > ',' ':60);
           writeln(' ':79);
           gotoxy(17,19);
           readln(tempstr);
           anguish := tempstr;
           if anguish[1] = '-' then begin
             writeln(' ':79);
             writeln('Sorry, can''t do negatives with this variable.');
             readln;
             goto x2;
           end;
           IF LENGTH(anguish) > 34 then begin
             writeln(' ':79);
             writeln('String Too Long.');
             readln;
             goto x2;
           end;
           a9:
           IF POS('%',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('%',anguish)-1) do f := f + anguish[v];
               for v := (POS('%',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '';
               anguish := f+g+h;
               goto a9;
           end;
           IF POS('LEVEL',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('LEVEL',anguish)-1) do f := f + anguish[v];
               for v := (POS('LEVEL',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '1';
               anguish := f+g+h;
               goto a9;
           end;
           val(anguish,valled,errcode);
           IF ERRCODE = 0 then evenrec[t].laysinc := tempstr;
         end;
      'E': begin
           gotoxy(1,13);
           writeln(' ':79);
           textcolor(14);
           writeln('This is the CHANGE of SKILL given to a player who gets this event.');
           writeln('Use "LEVEL" (all caps) for a user''s level, * for multiplication,');
           writeln('And \ for division.  Sorry, no Exponents, just use Number*Number.');
           writeln('Use a % sign at the end to do percents (i.e. 5% would be 5 percent)');
           writeln('NOTE: This adds/takes away skill from the user''s CURRENT skill.');
           writeln(' ':79);
           textcolor(13);
           write('Skill Change? > ',' ':60);
           writeln(' ':79);
           gotoxy(17,19);
           readln(tempstr);
           anguish := tempstr;
           if anguish[1] = '-' then begin
             writeln(' ':79);
             writeln('Sorry, can''t do negatives with this variable.');
             readln;
             goto x2;
           end;
           IF LENGTH(anguish) > 34 then begin
             writeln(' ':79);
             writeln('String Too Long.');
             readln;
             goto x2;
           end;
           a10:
           IF POS('%',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('%',anguish)-1) do f := f + anguish[v];
               for v := (POS('%',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '';
               anguish := f+g+h;
               goto a10;
           end;
           IF POS('LEVEL',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('LEVEL',anguish)-1) do f := f + anguish[v];
               for v := (POS('LEVEL',anguish)+6) to length(anguish) do h := h +anguish[v];
               g := '1';
               anguish := f+g+h;
               goto a10;
           end;
           val(anguish,valled,errcode);
           IF ERRCODE = 0 then evenrec[t].skillinc := tempstr;
         end;
      'F': begin
             clrscr;
             gotoxy(1,10);
             writeln(' ':79);
             textcolor(14);
             writeln('This value determines whom the event acts upon.  Please pick one!');
             writeln(' ':79);
             textcolor(10);
             write('[1] ');
             textcolor(11);
             writeln('All Users');
             textcolor(10);
             write('[2] ');
             textcolor(11);
             writeln('Female Users Only');
             textcolor(10);
             write('[3] ');
             textcolor(11);
             writeln('Male Users Only');
             textcolor(10);
             write('[4] ');
             textcolor(11);
             writeln('Above Level X (definable)');
             textcolor(10);
             write('[5] ');
             textcolor(11);
             writeln('Below Level X (definable)');
             textcolor(10);
             write('[6] ');
             textcolor(11);
             writeln('First X Players (definable)');
             textcolor(10);
             write('[7] ');
             textcolor(11);
             writeln('Last X Players (definable)');
             textcolor(10);
             write('[8] ');
             textcolor(11);
             writeln('Random X Players (definable)');
             textcolor(10);
             write('[9] ');
             textcolor(11);
             writeln('In Inn');
             textcolor(10);
             write('[0] ');
             textcolor(11);
             writeln('In Fields');
             textcolor(10);
             write('[A] ');
             textcolor(11);
             writeln('Has Kids');
             writeln(' ':79);
             writeln('Your Choice? > ');
             runother;
           end;
      'N': begin
             IF NOT REGISTERED and (w = 10) THEN begin
                writeln(' ':79);
                writeln('Sorry, you have an unregistered copy of LordEvent.');
                writeln('Only 10 Events in the unregistered version!');
                writeln('Registration is _easy_! Just call my BBS and leave e-mail!');
                readln;
             end;
             IF (w < 100) and REGISTERED then begin
               inc(w);
               t := w;
               evenrec[t].message := '*Generic*';
               evenrec[t].message2 := 'Call the Basement BBS!  (704)628-9908/(704)628-0017';
               evenrec[t].message3 := 'Edit me!';
               evenrec[t].log := 'Your SysOp didn''t modify his events properly!';
               evenrec[t].expinc := '0';
               evenrec[t].definc := '0';
               evenrec[t].strinc := '0';
               evenrec[t].hitinc := '0';
               evenrec[t].ffinc := '0';
               evenrec[t].pfinc := '0';
               evenrec[t].goldinc := '0';
               evenrec[t].skillinc := '0';
               evenrec[t].charminc := '0';
               evenrec[t].laysinc := '0';
               evenrec[t].directed := 'All';
               evenrec[t].dirvar := 0;
               evenrec[t].pair := 0;
             end;
             if NOT (REGISTERED) and (w < 10) then begin
               inc(w);
               t := w;
               evenrec[t].message := '*Generic*';
               evenrec[t].message2 := 'Call the Basement BBS!  (704)628-9908/(704)628-0017';
               evenrec[t].message3 := 'Edit me!';
               evenrec[t].log := 'Your SysOp didn''t modify his events properly!';
               evenrec[t].expinc := '0';
               evenrec[t].definc := '0';
               evenrec[t].strinc := '0';
               evenrec[t].hitinc := '0';
               evenrec[t].ffinc := '0';
               evenrec[t].pfinc := '0';
               evenrec[t].goldinc := '0';
               evenrec[t].directed := 'All';
               evenrec[t].dirvar := 0;
               evenrec[t].pair := 0;
             end;
             if w > 100 then begin
               writeln(' ':79);
               writeln('----> You''ve already filled all 100 spaces.  Read EVENT.DOC for');
               writeln('      info on running more than 100 events.... It''s easy! <----');
               readln;
             end;
          end;
      'G': begin
             clrscr;
             gotoxy(1,6);
             textcolor(14);
             writeln(' ':79);
             writeln('This is the number of the event that this event is PAIRED to.');
             writeln('For instance, if you had an event that added to females'' strength,');
             writeln('And decreased males'' defense, you''d want to run both, instead of just one.');
             writeln('Remember to put the correct pair numbers in _both_ events!');
             writeln(' ':79);
             writeln('Additionally, if you needed to pair more than two events, do a circle loop:');
             writeln('Ex: #1 - #2 - #3 - #4 - #1');
             writeln('You can link up to 10 events together.');
             writeln(' ':79);
             writeln('This value should be set to 0 if there is no linked event.');
             writeln(' ':79);
             write('This event - paired to: ');
             readln(evenrec[t].pair);
           end;
      'X': begin
            for v := t to (w-1) do begin
               evenrec[v] := evenrec[v+1];
               IF (evenrec[v].pair > 0) then dec(evenrec[v].pair);
            end;
            dec(w);
            IF W < t then t := w;
           end;
      ']': begin
             IF NOT REGISTERED and (w = 10) THEN begin
                writeln(' ':79);
                writeln('Sorry, you have an unregistered copy of LordEvent.');
                writeln('Only 10 Events in the unregistered version!');
                writeln('Registration is _easy_! Just call my BBS and leave e-mail!');
                readln;
             end;
             IF (w < 100) and REGISTERED then begin
               inc(w);
               v := w;
               evenrec[v] := evenrec[t];
               t := w;
             end
             else begin
               writeln(' ':79);
               writeln('----> You''ve already filled all 100 spaces.  Read EVENT.DOC for');
               writeln('      info on running more than 100 events.... It''s easy! <----');
               readln;
             end;
          end;
      '.','>':IF T < w then inc(t);
      ',','<':IF T > 1 then dec(t);
      'Q':begin
            assign(evenfile, 'event.dat');
            rewrite(evenfile);
            for t := 1 to w do write(evenfile, evenrec[t]);
            close(evenfile);
            exit;
         end;

      end;
    until done;
  end;

procedure cfgedit;
 var temp: array[1..2] of byte;
     y: byte;
    done:boolean;
    ch,c:char;
  begin
    done := false;
    assign(data, 'event.cfg');
    reset(data);
    readln(data,nom);
    readln(data,bbs);
    read(data,path);
    for y := 1 to 2 do readln(data,temp[y]);
    close(data);
    repeat
    clrscr;
    textcolor(15);
    writeln('Configuration Editor...');
    writeln;
    textcolor(10);
    write('1\ Name: ');
    textcolor(11);
    writeln(nom);
    textcolor(10);
    write('2\ BBS : ');
    textcolor(11);
    writeln(bbs);
    textcolor(10);
    write('3\ Path: ');
    textcolor(11);
    writeln(path);
    writeln;
    textcolor(15);
    write('LordEvent ');
    IF temp[1] = 1 then writeln('has a random chance (1 in ',temp[2],') of running.')
    else writeln('runs ',temp[2],' times a night.');
    writeln;
    textcolor(14);
    writeln('<Q>uit to Main   <E>dit Run Ops   <1> Edit Name   <2> Edit BBS   <3> Edit Path');
    ch := readkey;
    CASE UPCASE(ch) of
    'Q': begin
           assign(data,'event.cfg');
           rewrite(data);
           writeln(data,nom);
           writeln(data,bbs);
           writeln(data,path);
           writeln(data,temp[1]);
           writeln(data,temp[2]);
           writeln(data,reg);
           close(data);
           exit;
         end;
    'E': begin
          writeln;
          write('Do you want LordEvent to run randomly? [Y/N] ');
          c := readkey;
          IF UPCASE(c) = 'Y' then begin
             temp[1] := 1;
             writeln;
             write('1 out of how many times? ');
             readln(temp[2]);
          end
          else begin
             temp[1] := 0;
             writeln;
             write('How many times per night? ');
             readln(temp[2]);
          end;
        end;
    '1': begin
           writeln;
           writeln('Your Name? ');
           readln(nom);
         end;
    '2': begin
           writeln;
           writeln('Your BBS Name? ');
           readln(bbs);
         end;
    '3': begin
           writeln;
           writeln('Path to the Lord files? ');
           readln(path);

           IF NOT (ORD(path[length(path)]) = 92) then path := path + '\';
         end;
    end;
  until done;
 end;



procedure register;
  begin
    clrscr;
    textcolor(15);
    write('Your REG Code please? ');
    readln(reg);
  end;

procedure configuration;
 var ch:char;
     done: boolean;
     t:array[1..15] of byte;
     s:array[1..3] of byte;
     r:byte;
     tempstr : string;
     x,z,d,e,a,f,g:byte;
  begin
    for e := 1 to 15 do t[e] := e;
    s[1] := 8;
    s[2] := 7;
    s[3] := 15;
    d := 1;
    x := 1;
    z := 1;
    F := 1;
    e := 50;
    g := 72;
    r := 25;
    done := false;
    repeat
    chk4reg;
    registered := true;
    clrscr;
    textcolor(15);
    writeln('Configuration...');
    writeln;
    write('LordEvent is Registered TO: ');
    IF REGISTERED then writeln(nom) else writeln('UNREGISTERED');
    writeln;
    writeln;
    textcolor(11);
    writeln('<E>vent Editor');
    writeln('<C>onfig Editor');
    writeln('<Q>uit to Main');
    writeln;
    ch := readkey;
    CASE UPCASE(ch) of
    'E':eventedit;
    'C':cfgedit;
    'Q':begin
          clrscr;
          IF keypressed then ch := readkey;
          IF keypressed then ch := readkey;
          repeat
            textcolor(15);
            writeln('                 The Lord Event Editor');
            textcolor(14);
            writeln('                            programmed by Joseph Masters');
            writeln('');
            textcolor(10);
            writeln('    Written in honor of Seth Able Robinson & the Beaufort Co (SC) SysOps');
            writeln('');
            textcolor(9);
            writeln('Home BBS --  The Basement BBS  (704)628-9908 (28.8 v.34) / (704)628-0017 (14.4)');
            writeln('');
            textcolor(12);
            writeln('');
            writeln('                                    A');
            textcolor(11);
            writeln('                                                        ');
            textcolor(13);
            writeln('                               Production!');
            writeln('');
            gotoxy(26,10);
            tempstr := 'Sons of Salami Software Group';
            for a := 1 to LENGTH(TEMPSTR) do begin
               IF (A < 4) then textcolor(t[a])
               else if (A > 3) and (A < 7) then textcolor(t[a-3])
               else if (A > 6) and (A < 10) then textcolor(t[a-6])
               else if (A > 9) and (A < 13) then textcolor(t[a-9])
               else if (A > 12) and (A < 16) then textcolor(t[a-12])
               else if (A > 15) and (A < 19) then textcolor(t[a-15])
               else if (A > 18) and (A < 22) then textcolor(t[a-18])
               else if (A > 21) and (A < 25) then textcolor(t[a-21])
               else if (A > 24) and (A < 28) then textcolor(t[a-24])
               else textcolor(t[a-27]);
               write(tempstr[1+(1*(a-1))]);
            end;
            for a := 1 to 3 do begin
               IF s[a] = 8 then s[a] := 7;
               IF s[a] = 7 then s[a] := 15;
               if s[a] = 15 then s[a] := 8;
            end;
            gotoxy(43,2);
            tempstr := 'Joseph Masters';
            for a := 1 to LENGTH(TEMPSTR) do begin
               IF (A < 16) then textcolor(t[a])
               else if (A > 15) and (A < 31) then textcolor(t[a-15])
               else textcolor(t[a-30]);
               write(tempstr[1+(1*(a-1))]);
            end;
            for a := 1 to 15 do IF t[a] = 15 theN t[a] := 1 else inc(t[a]);
            gotoxy(25,4);
            tempstr := 'Seth Able Robinson';
            for A := 1 to LENGTH(TEMPSTR) do begin
               IF (a = r) then begin
                 textbackground(1);
                 textcolor(3);
                 write(tempstr[a]);
                 textbackground(0);
                 textcolor(10);
               end
               else write(tempstr[a]);
            end;
{            IF R = LENGTH(TEMPSTR) then r := 25 else inc(r);
            gotoxy(e,5);
            CASE d of
            1:write('');
            2:write('-');
            3:write('/');
            4:write('|');
            5:write('');
            6:write(')');
            7:write(']');
            8:write('>');
            end;
            IF (E = 72) then e := 50 else inc(e);
            IF (z = 3) then begin
               IF (D = 8) then d := 1 else inc(d);
               z := 1;
            end
            else inc(z);
            gotoxy(g,7);
            CASE d of
            1:write('<');
            2:write('[');
            3:write('(');
            4:write('{');
            5:write('|');
            6:write('\');
            7:write('-');
            8:write('');
            end;        }
            IF (g = 50) then g := 72 else dec(g);
            IF (x = 3) then begin
               IF (D = 8) then d := 1 else inc(d);
               x := 1;
            end
            else inc(x);
            delay(100);
            gotoxy(1,1);
          until keypressed;
          clrscr;
          halt;
    end;
   end;
   until done;
  end;

procedure READIN;
  begin
    i := 0;
    assign(playfile,path+'player.dat');
    reset(playfile);
    repeat
      inc(i);
      read(playfile,playrec[i]^);
      IF playrec[I]^.on_now then begin
         writeln('A PLAYER IS ON-LINE!');
         close(playfile);
         halt;
      end;
    until eof(playfile);
  end;



procedure chooseevent;
  label lab;
  var thatvar,h,errcode,j:integer;
  begin
    randomize;
    t := 0;
    h := 0;
    assign(evenfile,'event.dat');
    reset(evenfile);
    repeat
      inc(h);
      inc(t);
      read(evenfile,evenrec[t]);
    until eof(evenfile);
    IF NOT (REGISTERED) and (H > 10) then h := 10;
    close(evenfile);
    j := 1+RANDOM(200);
    for thatvar := 1 to j  do t := random(h);
    inc(t);
    if not (paramstr(1) = '') then val(paramstr(1),h,errcode);
    IF errcode = 0 then t := h;
{    IF t < 1 then t := 1;}
  end;


procedure logwrite;
  var ty,ti : byte;
      temp:array[1..200] of string;
      devilish:string;
      line1,line2,line3,lin4:string;
  begin
    IF POS(evenrec[t].log,'BLANK')>0 then exit;
    assign(data,path+'lognow.txt');
    reset(data);
    ty := 0;
    repeat
      inc(ty);
      readln(data, temp[ty]);
    until eof(data);
    close(data);
    assign(data,path+'lognow.txt');
    rewrite(data);
    writeln(data,temp[1]);
    writeln(data,temp[2]);
    writeln(data,temp[3]);
    writeln(data,temp[4]);
    writeln(data,'`2  ',evenrec[t].log);
    writeln(data,'`.                                `2-`0=`2-`0=`2-`0=`2-');
    for ti := 5 to ty do writeln(data, temp[ti]);
    close(data);
  end;


function convert(anguish:string;x:longint):longint;
label a1,a2,a3;
var v,m:byte;
   tempstr,f,g,h:string;
   errcode:integer;
   valled:longint;
   realtemp: array[1..20] of char;
   realnum: array[1..20] of longint;
   times,divs,adds,subs:byte;
   yelp,percent,negative:boolean;
begin
    negative := false;
    if anguish[1] = '-' then negative := true;
    f := '';
    if negative then for m := 2 to length(anguish) do f := F+anguish[m];
    if negative then anguish := f;
    yelp := false;
    percent := false;
    times := 0;
    divs := 0;
    adds := 0;
    subs := 0;
    a1:
           IF POS('LEVEL',anguish) > 0 then begin
               f := '';
               g := '';
               h := '';
               for v := 1 to (POS('LEVEL',anguish)-1) do f := f + anguish[v];
               for v := (POS('LEVEL',anguish)+5) to length(anguish) do h := h + anguish[v];
               str(playrec[z]^.level,tempstr);
               g := tempstr;
               anguish := f+g+h;
               goto a1;
           end;
         IF POS('%',anguish) > 0 then begin
             percent := true;
             f := '';
           h := '';
           for v := 1 to (POS('%',anguish)-1) do f := f + anguish[v];
           for v := (POS('%',anguish)+1) to length(anguish) do h := h+anguish[v];
           anguish := f+h;
         end;
    val(anguish,valled,errcode);
    m := 0;
    a2:
    inc(m);
         IF (POS('*',anguish) > 0) or (POS('+',anguish) > 0) or (POS('-',anguish) > 0) or (POS('/',anguish) > 0)then begin
               yelp := true;
               f := '';
               g := '';
               h := '';
               times := 0;
               divs := 0;
               adds := 0;
               subs := 0;
               IF (POS('*',anguish) > 0) then times := (POS('*',anguish));
               IF (POS('-',anguish) > 0) then subs := (POS('-',anguish));
               IF (POS('+',anguish) > 0) then adds := (POS('+',anguish));
               IF (POS('/',anguish) > 0) then divs := (POS('/',anguish));
               IF NOT (TIMES = 0) then begin
                  IF ((TIMES > subs) or (times = 0)) and ((TIMES > ADDS) or (adds = 0)) and ((TIMES > DIVS) or (DIVS > 0))
                  then begin
                      for v := 1 to (POS('*',anguish)-1) do f := f + anguish[v];
                      for v := (POS('*',anguish)+1) to length(anguish) do h := h + anguish[v];
                      val(f,realnum[m],errcode);
                      realtemp[m] := '*';
                      anguish := h;
                      goto a2;
                  end;
               end;
               IF (SUBS > 0) then begin
                  IF ((SUBS > times) or (timeS = 0)) and ((SUBS > ADDS) or (adds = 0)) and ((SUBS > DIVS) or (DIVS > 0))
                  then begin
                      for v := 1 to (POS('-',anguish)-1) do f := f + anguish[v];
                      for v := (POS('-',anguish)+1) to length(anguish) do h := h + anguish[v];
                      val(f,realnum[m],errcode);
                      realtemp[m] := '-';
                      anguish := h;
                      goto a2;
                  end;
               end;
               IF NOT (ADDS = 0) then begin
                  IF ((ADDS > timeS) or (timeS = 0)) and ((ADDS > subS) or (subs = 0)) and ((ADDS > DIVS) or (DIVS > 0))
                  then begin
                      for v := 1 to (POS('+',anguish)-1) do f := f + anguish[v];
                      for v := (POS('+',anguish)+1) to length(anguish) do h := h + anguish[v];
                      val(f,realnum[m],errcode);
                      realtemp[m] := '+';
                      anguish := h;
                      goto a2;
                  end;
               end;
               IF NOT (DIVS = 0) then begin
                  IF ((DIVS > subs) or (DIVS = 0)) and ((DIVS > ADDS) or (adds = 0)) and ((DIVS > times) or (times > 0))
                  then begin
                      for v := 1 to (POS('/',anguish)-1) do f := f + anguish[v];
                      for v := (POS('/',anguish)+1) to length(anguish) do h := h + anguish[v];
                      val(f,realnum[m],errcode);
                      realtemp[m] := '/';
                      anguish := h;
                      goto a2;
                  end;
               end;
         end;
               IF NOT YELP THEN GOTO A3;
               val(anguish,realnum[m],errcode);
               valled := realnum[1];
               for v := 2 to m do begin
                  IF realtemp[v-1] = '*' then valled := valled*realnum[v]
                  else IF realtemp[v-1] = '-' then valled := valled-realnum[v]
                  else IF realtemp[v-1] = '+' then valled := valled+realnum[v]
                  else IF realtemp[v-1] = '/' then valled := valled DIV realnum[v]
                  else valled := valled;
               end;

a3:
IF PERCENT then valled := (x*valled) DIV 100;
if negative then valled := valled*(-1);
{writeln('V2: ',valled);
if negative then valled := valled-(valled+valled);}
convert := valled;
end;

function check(tempstr:string):string;
  var f,g,h:string;
      y:byte;
  begin
    if (POS('-',tempstr) > 0) and (tempstr[POS('-',tempstr)+1] IN ['1','2','3','4','5','6','7','8','9','0']) then begin
      f := '';
      for y := 1 to POS('-',tempstr)-1 do f := f+tempstr[y];
      g := '';
      for y := POS('-',tempstr)+1 to length(tempstr) do g := g+tempstr[y];
      tempstr := f+g;
    end;
   check := tempstr;
  end;






procedure playerrun;
 label yank,tank;
  var d,b,v:byte;
   s:array[1..10] of longint;
   tempstr,anguish,f,g,h:string;
   fake,fake2,fake3:string;
   female,male,above,below,first,last,rand,fields,kids,inn:boolean;
   valled: longint;
  begin
    for d := 1 to 10 do s[d] := 0;
    female := false;
    fields := false;kids := false;inn := false;
    male := false;
    above := false;
    below := false;
    first := false;
    last := false;
    rand := false;
    d := 1;
    b := i;
    IF evenrec[t].directed = 'Female' then female := true;
    IF evenrec[t].directed = 'Male' then male := true;
    IF evenrec[t].directed = 'Above' then above := true;
    IF evenrec[t].directed = 'Below' then below := true;
    IF evenrec[t].directed = 'First' then first := true;
    IF evenrec[t].directed = 'Random' then rand := true;
    IF EVENREC[t].directed = 'Kids' then kids := true;
    IF EVENREC[t].directed = 'Fields' then fields := true;
    IF EVENREC[t].directed = 'Inn' then inn := true;
    IF FIRST and (b > evenrec[t].dirvar) then b := evenrec[t].dirvar;
    IF LAST AND (d > evenrec[t].dirvar) then d := evenrec[t].dirvar;
    for z := d to b do begin
      if (playrec[z]^.real_names = 'X') or (playrec[z]^.names = '') then goto yank;
      for v := 1 to uckp do begin
        IF z = uck[v] then goto yank;
      end;
      fake := evenrec[t].message;
      fake2 := evenrec[t].message2;
      fake3 := evenrec[t].message3;
      IF FEMALE And (playrec[z]^.sex = 0) then goto yank;
      IF MALE and (playrec[z]^.sex = 5) then goto yank;
      IF BELOW and (playrec[z]^.level > evenrec[t].dirvar) then goto yank;
      IF ABOVE and (playrec[z]^.level < evenrec[t].dirvar) then goto yank;
      IF KIDS and (playrec[z]^.kids = 0) then goto yank;
      IF INN and (playrec[z]^.inn = 0) then goto yank;
      IF FIELDS and (playrec[z]^.inn = 5) then goto yank;
      IF (RAND) and not (RANDOM(evenrec[t].dirvar) = 0) then goto yank;
      inc(uckp);
      uck[uckp] := z;
        IF NOT (evenrec[t].expinc = '0') then begin
           valled := convert(evenrec[t].expinc,playrec[z]^.exp);
           IF POS('%1',fake) > 0 then begin
             f := '';
             for v := 1 to pos('%1',fake)-1 do f := f +fake[v];
             str(valled,g);
             h := '';
             for v := pos('%1',fake)+2 to length(fake) do h := h+fake[v];
             fake := f+g+h;
           end;
           IF POS('%1',fake2) > 0 then begin
             f := '';
             for v := 1 to pos('%1',fake2)-1 do f := f +fake2[v];
             str(valled,g);
             h := '';;
             for v := pos('%1',fake2)+2 to length(fake2) do h := h+fake2[v];
             fake2 := f+g+h;
           end;
           IF POS('%1',fake3) > 0 then begin
             f := '';
             for v := 1 to pos('%1',fake3)-1 do f := f +fake3[v];
             str(valled,g);
             h := '';
             for v := pos('%1',fake3)+2 to length(fake3) do h := h+fake3[v];
             fake3 := f+g+h;
           end;
         s[1] := valled;
        end;
        IF NOT (evenrec[t].definc = '0') then begin
           valled := convert(evenrec[t].definc,playrec[z]^.def);
           IF POS('%2',fake) > 0 then begin
             f := '';
             for v := 1 to pos('%2',fake)-1 do f := f +fake[v];
             str(valled,g);
             h := '';
             for v := pos('%2',fake)+2 to length(fake) do h := h+fake[v];
             fake := f+g+h;
           end;
           IF POS('%2',fake2) > 0 then begin
             f := '';
             for v := 1 to pos('%2',fake2)-1 do f := f +fake2[v];
             str(valled,g);
             h := '';
             for v := pos('%2',fake2)+2 to length(fake2) do h := h+fake2[v];
             fake2 := f+g+h;
           end;
           IF POS('%2',fake3) > 0 then begin
             f := '';
             for v := 1 to pos('%2',fake3)-1 do f := f +fake3[v];
             str(valled,g);
             h := '';
             for v := pos('%2',fake3)+2 to length(fake3) do h := h+fake3[v];
             fake3 := f+g+h;
           end;
          s[2] := valled;
        end;
        IF NOT (evenrec[t].strinc = '0') then begin

           valled := convert(evenrec[t].strinc,playrec[z]^.strength);
           IF POS('%3',fake) > 0 then begin
             f := '';
             for v := 1 to pos('%3',fake)-1 do f := f +fake[v];
             str(valled,g);
             h := '';
             for v := pos('%3',fake)+2 to length(fake) do h := h+fake[v];
             fake := f+g+h;
           end;
           IF POS('%3',fake2) > 0 then begin
             f := '';
             for v := 1 to pos('%3',fake2)-1 do f := f +fake2[v];
             str(valled,g);
             h := '';
             for v := pos('%3',fake2)+2 to length(fake2) do h := h+fake2[v];
             fake2 := f+g+h;
           end;
           IF POS('%3',fake3) > 0 then begin
             f := '';
             for v := 1 to pos('%3',fake3)-1 do f := f +fake3[v];
             str(valled,g);
             h := '';
             for v := pos('%3',fake3)+2 to length(fake3) do h := h+fake3[v];
             fake3 := f+g+h;
           end;
           s[3] := valled;
        end;
        IF NOT (evenrec[t].hitinc = '0') then begin
           valled := convert(evenrec[t].hitinc,playrec[z]^.hit_max);
           IF POS('%4',fake) > 0 then begin
             f := '';
             for v := 1 to pos('%4',fake)-1 do f := f +fake[v];
             str(valled,g);
             h := '';
             for v := pos('%4',fake)+2 to length(fake) do h := h+fake[v];
             fake := f+g+h;
           end;
           IF POS('%4',fake2) > 0 then begin
             f := '';
             for v := 1 to pos('%4',fake2)-1 do f := f +fake2[v];
             str(valled,g);
             h := '';
             for v := pos('%4',fake2)+2 to length(fake2) do h := h+fake2[v];
             fake2 := f+g+h;
           end;
           IF POS('%4',fake3) > 0 then begin
             f := '';
             for v := 1 to pos('%4',fake3)-1 do f := f +fake3[v];
             str(valled,g);
             h := '';
             for v := pos('%4',fake3)+2 to length(fake3) do h := h+fake3[v];
             fake3 := f+g+h;
           end;
         s[4] := valled;
        end;
        IF NOT (evenrec[t].ffinc = '0') then begin
           valled := convert(evenrec[t].ffinc,playrec[z]^.fights_left);
           IF (playrec[z]^.fights_left - valled) > 0 then dec(playrec[z]^.fights_left,valled) else
           IF POS('%5',fake) > 0 then begin
             f := '';
             for v := 1 to pos('%5',fake)-1 do f := f +fake[v];
             str(valled,g);
             h := '';
             for v := pos('%5',fake)+2 to length(fake) do h := h+fake[v];
             fake := f+g+h;
           end;
           IF POS('%5',fake2) > 0 then begin
             f := '';
             for v := 1 to pos('%5',fake2)-1 do f := f +fake2[v];
             str(valled,g);
             h := '';
             for v := pos('%5',fake2)+2 to length(fake2) do h := h+fake2[v];
             fake2 := f+g+h;
           end;
           IF POS('%5',fake3) > 0 then begin
             f := '';
             for v := 1 to pos('%5',fake3)-1 do f := f +fake3[v];
             str(valled,g);
             h := '';
             for v := pos('%5',fake3)+2 to length(fake3) do h := h+fake3[v];
             fake3 := f+g+h;
           end;
          s[5] := valled;
        end;
        IF NOT (evenrec[t].pfinc = '0') then begin
           valled := convert(evenrec[t].pfinc,playrec[z]^.human_left);
           IF POS('%6',fake) > 0 then begin
             f := '';
             for v := 1 to pos('%6',fake)-1 do f := f +fake[v];
             str(valled,g);
             h := '';
             for v := pos('%6',fake)+2 to length(fake) do h := h+fake[v];
             fake := f+g+h;
           end;
           IF POS('%6',fake2) > 0 then begin
             f := '';
             for v := 1 to pos('%6',fake2)-1 do f := f +fake2[v];
             str(valled,g);
             h := '';
             for v := pos('%6',fake2)+2 to length(fake2) do h := h+fake2[v];
             fake2 := f+g+h;
           end;
           IF POS('%6',fake3) > 0 then begin
             f := '';
             for v := 1 to pos('%6',fake3)-1 do f := f +fake3[v];
             str(valled,g);
             h := '';
             for v := pos('%6',fake3)+2 to length(fake3) do h := h+fake3[v];
             fake3 := f+g+h;
           end;
          s[6] := valled;
        end;
        IF NOT (evenrec[t].goldinc = '0') then begin
           valled := convert(evenrec[t].goldinc,playrec[z]^.bank);
           IF POS('%7',fake) > 0 then begin
             f := '';
             for v := 1 to pos('%7',fake)-1 do f := f +fake[v];
             str(valled,g);
             h := '';
             for v := pos('%7',fake)+2 to length(fake) do h := h+fake[v];
             fake := f+g+h;
           end;
           IF POS('%7',fake2) > 0 then begin
             f := '';
             for v := 1 to pos('%7',fake2)-1 do f := f +fake2[v];
             str(valled,g);
             h := '';
             for v := pos('%7',fake2)+2 to length(fake2) do h := h+fake2[v];
             fake2 := f+g+h;
           end;
           IF POS('%7',fake3) > 0 then begin
             f := '';
             for v := 1 to pos('%7',fake3)-1 do f := f +fake3[v];
             str(valled,g);
             h := '';
             for v := pos('%7',fake3)+2 to length(fake3) do h := h+fake3[v];
             fake3 := f+g+h;
           end;
         s[7] := valled;
        end;
        IF NOT (evenrec[t].charminc = '0') then begin
           valled := convert(evenrec[t].charminc,playrec[z]^.charm);
           IF POS('%8',fake) > 0 then begin
             f := '';
             for v := 1 to pos('%8',fake)-1 do f := f +fake[v];
             str(valled,g);
             h := '';
             for v := pos('%8',fake)+2 to length(fake) do h := h+fake[v];
             fake := f+g+h;
           end;
           IF POS('%8',fake2) > 0 then begin
             f := '';
             for v := 1 to pos('%8',fake2)-1 do f := f +fake2[v];
             str(valled,g);
             h := '';
             for v := pos('%8',fake2)+2 to length(fake2) do h := h+fake2[v];
             fake2 := f+g+h;
           end;
           IF POS('%8',fake3) > 0 then begin
             f := '';
             for v := 1 to pos('%8',fake3)-1 do f := f +fake3[v];
             str(valled,g);
             h := '';
             for v := pos('%8',fake3)+2 to length(fake3) do h := h+fake3[v];
             fake3 := f+g+h;
           end;
         s[8] := valled;
        end;
        IF NOT (evenrec[t].laysinc = '0') then begin
           valled := convert(evenrec[t].laysinc,playrec[z]^.lays);
           IF POS('%9',fake) > 0 then begin
             f := '';
             for v := 1 to pos('%9',fake)-1 do f := f +fake[v];
             str(valled,g);
             h := '';
             for v := pos('%9',fake)+2 to length(fake) do h := h+fake[v];
             fake := f+g+h;
           end;
           IF POS('%9',fake2) > 0 then begin
             f := '';
             for v := 1 to pos('%9',fake2)-1 do f := f +fake2[v];
             str(valled,g);
             h := '';
             for v := pos('%9',fake2)+2 to length(fake2) do h := h+fake2[v];
             fake2 := f+g+h;
           end;
           IF POS('%9',fake3) > 0 then begin
             f := '';
             for v := 1 to pos('%9',fake3)-1 do f := f +fake3[v];
             str(valled,g);
             h := '';
             for v := pos('%9',fake3)+2 to length(fake3) do h := h+fake3[v];
             fake3 := f+g+h;
           end;
         s[9] := valled;
        end;
        IF NOT (evenrec[t].skillinc = '0') then begin
           IF (playrec[z]^.class = 1) then valled := convert(evenrec[t].skillinc,playrec[z]^.skillw);
           IF (playrec[z]^.class = 2) then valled := convert(evenrec[t].skillinc,playrec[z]^.skillm);
           IF (playrec[z]^.class = 3) then valled := convert(evenrec[t].skillinc,playrec[z]^.skillt);
           IF POS('%0',fake) > 0 then begin
             f := '';
             for v := 1 to pos('%0',fake)-1 do f := f +fake[v];
             str(valled,g);
             h := '';
             for v := pos('%0',fake)+2 to length(fake) do h := h+fake[v];
             fake := f+g+h;
           end;
           IF POS('%0',fake2) > 0 then begin
             f := '';
             for v := 1 to pos('%0',fake2)-1 do f := f +fake2[v];
             str(valled,g);
             h := '';
             for v := pos('%0',fake2)+2 to length(fake2) do h := h+fake2[v];
             fake2 := f+g+h;
           end;
           IF POS('%0',fake3) > 0 then begin
             f := '';
             for v := 1 to pos('%0',fake3)-1 do f := f +fake3[v];
             str(valled,g);
             h := '';
             for v := pos('%0',fake3)+2 to length(fake3) do h := h+fake3[v];
             fake3 := f+g+h;
           end;
         s[10] := valled;
        end;


      fake := check(fake);
      fake2 := check(fake2);
      fake3 := check(fake3);
         str(z-1,tempstr);
         IF NOT FILEEXISTS(path+'mail'+tempstr+'.dat') then begin
           assign(data, path+'mail'+tempstr+'.dat');
           rewrite(data);
           close(data);
         end;
         assign(data, path+'mail'+tempstr+'.dat');
         append(data);
         IF POS('BLANK',fake) = 0 then writeln(data,'`2');
         IF POS('BLANK',fake) = 0 then writeln(data,'`%                          -*- Lord Event -*-');
IF POS('BLANK',fake) = 0 then
writeln(data,'`2-=-=-=--=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=');
         IF POS('BLANK',fake) = 0 then writeln(data,'`2  ',fake);
         IF POS('BLANK',fake2) = 0 then writeln(data,'`2  ',fake2);
         IF POS('BLANK',fake3) = 0 then writeln(data,'`2  ',fake3);
         IF not (s[1] = 0) then writeln(data,'`E',s[1]);
         IF not (s[2] = 0) then writeln(data,'`D',s[2]);
         IF not (s[3] = 0) then writeln(data,'`M',s[3]);
         IF not (s[4] = 0) then writeln(data,'`;',s[4]);
         IF not (s[5] = 0) then writeln(data,'`,',s[5]);
         IF not (s[6] = 0) then writeln(data,'`:',s[6]);
         IF not (s[7] = 0) then writeln(data,'`b',s[7]);
         IF not (s[10] = 0) then for valled := 1 to s[8] do writeln(data,'`S');
         if not (s[8] = 0) then for valled := 1 to s[8] do writeln(data,'`}');
         IF not (s[9] = 0) then for valled := 1 to s[9] do writeln(data,'`{');
         writeln(data,'`2');
         close(data);

    yank:
  end;
{  assign(playfile,path+'player.dat');
  rewrite(playfile);
  for z := 1 to i do write(playfile,playrec[z]^);
  close(playfile);}
end;



{procedure mailrun;
 label yank;
 var tempstr: string;
   d,b:byte;
   f,g,h:string[100];
  female,male,above,below,first,last,rand:boolean;
  begin
    female := false;
    male := false;
    above := false;
    below := false;
    first := false;
    last := false;
    rand := false;
    d := 1;
    b := i;
    IF evenrec[t].directed = 'Female' then female := true;
    IF evenrec[t].directed = 'Male' then male := true;
    IF evenrec[t].directed = 'Above' then above := true;
    IF evenrec[t].directed = 'Below' then below := true;
    IF evenrec[t].directed = 'First' then first := true;
    IF evenrec[t].directed = 'Random' then rand := true;
    IF rand then exit;
    IF FIRST and (b > evenrec[t].dirvar) then b := evenrec[t].dirvar;
    IF LAST AND (d > evenrec[t].dirvar) then d := evenrec[t].dirvar;
    for z := d to b do begin

       str(z-1,tempstr);
       if (playrec[z]^.real_names = 'X') or (playrec[z]^.names = '') then goto yank;
      IF FEMALE And (playrec[z]^.sex = 0) then goto yank;
      IF MALE and (playrec[z]^.sex = 5) then goto yank;
      IF BELOW and (playrec[z]^.level > evenrec[t].dirvar) then goto yank;
      IF ABOVE and (playrec[z]^.level < evenrec[t].dirvar) then goto yank;
      IF NOT FILEEXISTS(path+'mail'+tempstr+'.dat') then begin
        assign(data, path+'mail'+tempstr+'.dat');
        rewrite(data);
        close(data);
      end;


      assign(data, path+'mail'+tempstr+'.dat');
      append(data);
      writeln(data,'`2');
      writeln(data,'`%                          -*- Lord Event -*-');
      writeln(data,'`2-=-=-=--=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=');
      IF POS('BLANK',fake) = 0 then writeln(data,'`2  ',fake);
      IF POS('BLANK',fake2) = 0 then writeln(data,'`2  ',fake2);
      IF POS('BLANK',fake3) = 0 then writeln(data,'`2  ',fake3);
      writeln(data,'`2');
      close(data);
      yank:
    end;
end;}


begin
  {$M 65519,65536,655360}
  randomize;
  uckp := 0;
  for o := 1 to 150 do uck[o] := 0;
  for o := 1 to 149 do NEW(playrec[o]);
  registered := false;
  assign(data, 'event.cfg');
  reset(data);
  readln(data, nom);
  readln(data, bbs);
  readln(data, path);
  readln(data, gar);
  readln(data, gar2);
  readln(data,reg);
  close(data);
  chk4reg;
  IF (PARAMSTR(1) = 'CONFIG') or (Paramstr(1) = 'config') then configuration;
  IF NOT FILEEXISTS(path+'3rdparty.dat') then begin
    writeln('You''re not running LORD 3.25B+.  Please upgrade!  Call (704)628-9908!');
    halt;
  end;
  if not fileexists(path+'player.dat') then begin
     writeln('PLAYER.DAT does not exist where you said it did!');
     halt;
  end;
  IF NOT FileExists('eventime.dat') then begin
    assign(data2,'eventime.dat');
    rewrite(data2);
    GetDate(year,month,day,dow);
    str(year+month+day-1,datetest);
    writeln(data2, datetest);
    close(data2);
  end;
  assign(data2,'eventime.dat');
  reset(data2);
  readln(data2,datetest);
  close(data2);
  getdate(year,month,day,dow);
  str(year+month+day,datetest2);
  IF (datetest = datetest2) then begin
    clrscr;
    writeln('You''ve already run Maintenance today!');
    textcolor(15);
    writeln('To run it again (today) delete "EVENTIME.DAT"');
    halt;
  end;
  assign(data2,'eventime.dat');
  rewrite(data2);
  GetDate(year,month,day,dow);
  writeln(data2, year+month+day);
  close(data2);
  clrscr;
  writeln;
  textcolor(15);
  writeln('Reading in Data Files...');
  readin;
  writeln;
  gar4 := 0;
  IF (gar = 1) and (random(gar2) = 0) then begin
    chooseevent;
    ten1:
    inc(gar4);
    rec[gar4] := t;
    writeln('Choosing Event...');
    if gar4 = 1 then logwrite;
    writeln;
    writeln('Writing Log...');
    writeln;
    playerrun;
    writeln('Running through players...');
    writeln;
    writeln('Running through player mail...');
    IF (evenrec[t].pair > 0) and NOT (evenrec[t].pair = rec[1]) then begin
      t := evenrec[t].pair;
      goto ten1;
    end;
    halt;
  end;
  IF (gar = 0) then for gar3 := 1 to gar2 do begin
    chooseevent;
    ten2:
    inc(gar4);
    rec[gar4] := t;
    writeln('Choosing Event...');
    IF gar4 = 1 then logwrite;
    writeln;
    writeln('Writing Log...');
    writeln;
    playerrun;
    writeln('Running through players...');
    writeln;
    writeln('Running through player mail...');
    IF (evenrec[t].pair > 0) and NOT (evenrec[t].pair = rec[1]) then begin
      t := evenrec[t].pair;
      goto ten2;
    end;
  end;
end.
